# List Comprehension

L1 = [x*2 for x in range(1, 11)]

L2 = [x*2 for x in range(1, 11) if x*2 >= 12]

# List Comp to find List Length

def length(xs):
   return sum([1 for anything in xs])

def rep(x, n):
    return [x for something in range(n)]

def even(x):
    return x%2==0

def odd(x):
    return not(even(x))

def boomBangs(xs):
   return ["BOOM" if x < 10 else "BANG" for x in xs if odd(x)]

# List Comprehension With Two Lists
nouns = ["hobo", "frog", "pope"]
adjectives = ["lazy", "grouchy", "scheming"]
L3 = [adjective + ' ' + noun for noun in nouns for adjective in adjectives]

# Remove non UpperCase

def removeNonUpperCase(st):
   upCase = [chr(i) for i in range(ord('A'), ord('Z')+1)]
   return [c for c in st if c in upCase]

xxs = [[1,3,5,2,3,1,2,4,5],[1,2,3,4,5,6,7,8,9],[1,2,4,2,1,6,3,1,3,2,3,6]]

L4 = [[x for x in xs if even(x)] for xs in xxs ]

# Map

L7 = map(lambda x: x+'!', ["BIFF", "BANG", "POW"])

# Partial Functions

from functools import partial

def power(base, exponent):
    return base ** exponent

square = partial(power, exponent=2)
cube = partial(power, exponent=3)

# Partial Functions Example

def rep(x, n):
    return [x for i in range(n)]

def repit(xs):
    rep3 = partial(rep, n=3)
    return map(rep3, xs)

L10 = filter(lambda x: x%2==0, [2, 3, 4, 5, 1, 7, 89])

# Reduce

print reduce(lambda x, y: x + y, range(1, 101), 0)

print reduce(lambda x, y: x * y, range(1, 101), 1)

# Standard Deviation

from math import sqrt
def stdDev(A):
    add = lambda x, y: x+y
    N = float(len(A))
    mu = reduce(add, A, 0)/N
    tot = reduce(add, [(a-mu)**2 for a in A], 0)
    return sqrt(tot/N)

def forall(A):
    return reduce(lambda x, y: x and y, A, True)

print forall([True, True, True, True])
print forall([True, True, True, False])

# Contains

def contains(x, xs):
    return reduce(lambda a, b: a or b, [y==x for y in xs], False)

print contains(4, [3, 4, 5, 6, 8])
print contains("happy", adjectives)
